/* LogOut.h */

#ifndef __TIQMax_LogOut_h
#define __TIQMax_LogOut_h

#include <fstream>

#include "SpTrAr.h"
#include "ClArray.h"

extern ofstream tlog;

/* / log' (  TIQMMain.cpp) */
void createLogFileHeader( int argc, char*const argv[],  //   log 
                          const char* programName, const char* versionAndDate );
void finishLogFile( const char* programName );          //  log'

/*   TIQMMain.cpp */
//   log  
void logOutInitialTrees( RCClArray gTrees, RCSpeciesTree sTree );
//   log    
void logOutCutResults( RCClArray gTrees, int numberOfRemovedGenes );

/*   Optimize.cpp */
//   log   
void logOutInitialInjections( RCClArray gTrees, RCSpeciesTree sTree,
                              double initialQuality );
//   log  
void logOutOptimizedInjections( RCClArray gTrees, RCSpeciesTree sTree,
                                double resultQuality);
//   log    
void logOutNewTryHeader( int tryNum );
//   log    
void logOutNewRandomSpeciesTree( RCSpeciesTree sTree );
//   log   
void logOutBestSpeciesTrees( RCSpeciesTree sTree,
                             RCSpeciesTreesArray bestSTrees,
                             int numOfBestSTrees );

/*   TUtils.cpp */
//   log  ͣ ,    
void logOutAbsentGenes( RCSrtArray absentGenes, int numberOfAllGenes );

#endif // __TIQMax_LogOut_h

