/* Variable.h -      */

#ifndef __VARIABLE_H
#define __VARIABLE_H

#include <string.h>
#include <iostream>

using namespace std;

#include "ClsDefs.h"

_CLASSDEF(TVariable)

/*    */
class TVariable
  {

  public:

    TVariable( const char*, int );
    virtual ~TVariable() { delete name; }

    virtual void printon( ostream& ) = 0;

    char*      name; //  
    int        type; //  
    PTVariable next; //      

  };

_CLASSDEF(TVariableList)

/* ,    */
class TVariableList
  {

  public:

    TVariableList() : firstvariable(0) {}
    virtual ~TVariableList();

    virtual PTVariable add     ( PTVariable );
    virtual PTVariable find    ( const char* );
    virtual int        remove  ( const char* );
    virtual void       printon ( ostream& );

  protected:

    PTVariable firstvariable; //     

  };

inline ostream& operator<<( ostream& os, TVariableList& variablelist )
  { return variablelist.printon(os), os; }

#endif	// __VARIABLE_H

